
#include "Csound/csdl.h"

#include "babo.h"
#include "grain4.h"
#include "spat3d.h"

#define S(x)    sizeof(x)

extern  void    baboset_32(void*);
extern  void    babo_32(void*);
extern  void    grainsetv4_32(void*);
extern  void    graingenv4_32(void*);
extern  void    spat3dset_32(void*);
extern  void    spat3d_32(void*);
extern  void    spat3diset_32(void*);
extern  void    spat3di_32(void*);
extern  void    spat3dt_32(void*);

extern  void    baboset_64(void*);
extern  void    babo_64(void*);
extern  void    grainsetv4_64(void*);
extern  void    graingenv4_64(void*);
extern  void    spat3dset_64(void*);
extern  void    spat3d_64(void*);
extern  void    spat3diset_64(void*);
extern  void    spat3di_64(void*);
extern  void    spat3dt_64(void*);

static OENTRY op01_32 = {   "babo",     S(BABO),        5,
                                "aa",       "akkkiiijj",
                            baboset_32, NULL, babo_32           };
static OENTRY op02_32 = {   "spat3d",   S(SPAT3D),      5,
                                "aaaa",     "akkkiiiiio",
                            spat3dset_32, NULL, spat3d_32       };
static OENTRY op03_32 = {   "spat3di",  S(SPAT3D),      5,
                                "aaaa",     "aiiiiiio",
                            spat3diset_32, NULL, spat3di_32     };
static OENTRY op04_32 = {   "spat3dt",  S(SPAT3D),      1,
                                "",         "iiiiiiiio",
                            spat3dt_32, NULL, NULL              };
static OENTRY op05_32 = {   "granule",  S(GRAINV4),     5,
                                "a",        "xiiiiiiiiikikiiivppppo",
                            grainsetv4_32, NULL, graingenv4_32  };

static OENTRY op01_64 = {   "babo",     S(BABO),        5,
                                "aa",       "akkkiiijj",
                            baboset_64, NULL, babo_64           };
static OENTRY op02_64 = {   "spat3d",   S(SPAT3D),      5,
                                "aaaa",     "akkkiiiiio",
                            spat3dset_64, NULL, spat3d_64       };
static OENTRY op03_64 = {   "spat3di",  S(SPAT3D),      5,
                                "aaaa",     "aiiiiiio",
                            spat3diset_64, NULL, spat3di_64     };
static OENTRY op04_64 = {   "spat3dt",  S(SPAT3D),      1,
                                "",         "iiiiiiiio",
                            spat3dt_64, NULL, NULL              };
static OENTRY op05_64 = {   "granule",  S(GRAINV4),     5,
                                "a",        "xiiiiiiiiikikiiivppppo",
                            grainsetv4_64, NULL, graingenv4_64  };

static OENTRY *opcodes_32[] = {
    &op01_32, &op02_32, &op03_32, &op04_32, &op05_32, NULL
};

static OENTRY *opcodes_64[] = {
    &op01_64, &op02_64, &op03_64, &op04_64, &op05_64, NULL
};

long opcode_count(void *csound)
{
    int cnt;
    /* count the number of opcodes */
    for (cnt = 0; opcodes_32[cnt] != NULL; cnt++);
    return ((long) cnt);
}

void *opcode_init_32(void *csound)
{
    return ((void*) ((OENTRY**) opcodes_32));
}

void *opcode_init_64(void *csound)
{
    return ((void*) ((OENTRY**) opcodes_64));
}

